package com.qmth.teachcloud.mark.bean.vo.parseCard.pic;

import com.alibaba.fastjson.JSON;
import com.qmth.teachcloud.common.bean.dto.mark.PictureConfig;
import com.qmth.teachcloud.mark.bean.answercard.CardFile;
import org.apache.commons.collections4.CollectionUtils;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

public class SubPictureConfig implements Serializable {

    private int i;
    private Double x;
    private Double y;
    private Double w;
    private Double h;
    private Integer mainNumber;
    private String subNumber;
    private String questionNumber;
    private Integer questionType;
    private boolean singleQuestion;

    public SubPictureConfig() {
    }

    public SubPictureConfig(int i, Double x, Double y, Double w, Double h, Integer mainNumber, String subNumber, String questionNumber) {
        this.i = i;
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        this.mainNumber = mainNumber;
        this.subNumber = subNumber;
        this.questionNumber = questionNumber;
        this.singleQuestion = true;
    }

    public static String transfer(List<SubPictureConfig> subPictureConfigList, boolean addPosition) {
        if (CollectionUtils.isEmpty(subPictureConfigList)) {
            return null;
        }
        List<PictureConfig> configList = subPictureConfigList.stream().map(m -> {
            PictureConfig pictureConfig = new PictureConfig();
            pictureConfig.setI(m.getI());
            pictureConfig.setX(m.getX());
            pictureConfig.setY(m.getY());
            pictureConfig.setW(m.getW());
            pictureConfig.setH(m.getH());
            return pictureConfig;
        }).collect(Collectors.toList());
        if (addPosition) {
            return CardFile.getMarkConfigAddPic(configList, 0.015);
        } else {
            return JSON.toJSONString(configList);
        }
    }

    public int getI() {
        return i;
    }

    public void setI(int i) {
        this.i = i;
    }

    public Double getX() {
        return x;
    }

    public void setX(Double x) {
        this.x = x;
    }

    public Double getY() {
        return y;
    }

    public void setY(Double y) {
        this.y = y;
    }

    public Double getW() {
        return w;
    }

    public void setW(Double w) {
        this.w = w;
    }

    public Double getH() {
        return h;
    }

    public void setH(Double h) {
        this.h = h;
    }

    public Integer getMainNumber() {
        return mainNumber;
    }

    public void setMainNumber(Integer mainNumber) {
        this.mainNumber = mainNumber;
    }

    public String getSubNumber() {
        return subNumber;
    }

    public void setSubNumber(String subNumber) {
        this.subNumber = subNumber;
    }

    public String getQuestionNumber() {
        return questionNumber;
    }

    public void setQuestionNumber(String questionNumber) {
        this.questionNumber = questionNumber;
    }

    public Integer getQuestionType() {
        return questionType;
    }

    public void setQuestionType(Integer questionType) {
        this.questionType = questionType;
    }

    public boolean isSingleQuestion() {
        return singleQuestion;
    }

    public void setSingleQuestion(boolean singleQuestion) {
        this.singleQuestion = singleQuestion;
    }
}
